#!/usr/bin/python
# -*- coding: utf-8 -*-
from PyQt4 import QtCore, QtGui
try:
  import sqlite3
except:
  print "librerie per la connessione al database sqlite non trovate"

import os

from osgeo import gdal,ogr

def substance_extract(id_s,fields,dbloc=None):
	#estrazione valori sostanze
	if dbloc==None:
		dbloc=''
	conn = sqlite3.connect(dbloc+"substance.db")
	cursor=conn.cursor()

	sql_fields=""
	i=0
	for x in fields:
	  i+=1
	  sql_fields+=x
	  if i<len(fields):
	    sql_fields+=","
	query_substance="select "+sql_fields+" from substance where id="+str(id_s)

	cursor.execute(query_substance)

	sql_fetch=cursor.fetchall()

	res_fields=[]

	for row in sql_fetch:
	  for x in row:
	    res_fields.append(x)

	conn.close()

	return res_fields


def texture_extract(texture,fields,dbloc=None):
	#estrazione valori sostanze
	if dbloc==None:
		dbloc=''
	conn = sqlite3.connect(dbloc+"substance.db")
	cursor=conn.cursor()
	sql_fields=""
	i=0
	for x in fields:
	  i+=1
	  sql_fields+=x
	  if i<len(fields):
	    sql_fields+=","

	query_texture="select "+sql_fields+" from texture where nome like lower('"+str(texture)+"')"

	cursor.execute(query_texture)

	sql_fetch=cursor.fetchall()

	res_fields=[]

	for row in sql_fetch:
	  for x in row:
	    res_fields.append(x)

	conn.close()

	return res_fields



def air_extract(c_stability,outdoor,dbloc=None):
	if dbloc==None:
		dbloc=os.path.dirname(os.path.abspath(__file__))+"/"
	#print os.path.dirname(os.path.abspath(__file__))
	conn = sqlite3.connect(dbloc+"substance.db")
	cursor=conn.cursor()
	query_texture="select sigmay1,sigmay2,sigmayexp,sigmaz1,sigmaz2,sigmazexp from air_stability where class like lower('"+str(c_stability)+"') and outdoor like lower('"+str(outdoor)+"')"

	cursor.execute(query_texture)

	sql_fetch=cursor.fetchall()

	res_fields=[]

	for row in sql_fetch:
	  for x in row:
	    res_fields.append(x)

	conn.close()

	return res_fields



def cn_extract(cnl,soil,dbloc=None):
	if dbloc==None:
		dbloc=os.path.dirname(os.path.abspath(__file__))+"/"
	#print os.path.dirname(os.path.abspath(__file__))
	conn = sqlite3.connect(dbloc+"substance.db")
	cursor=conn.cursor()
	
	classecn="cn_"+str(cnl)
	query_cn="select "+classecn+" from cn where id = "+str(soil)
	#import pdb; pdb.set_trace()
	cursor.execute(query_cn)

	sql_fetch=cursor.fetchall()

	res_fields=[]

	for row in sql_fetch:
	  for x in row:
	    res_fields.append(x)

	conn.close()

	return res_fields


def array2raster(newRasterfn,xmin,ymin,pixelWidth,pixelHeight,xsize,ysize,array):
	# vedi https://pcjericks.github.io/py-gdalogr-cookbook/raster_layers.html#create-raster-from-array
    # cols = array.shape[1]
    # rows = array.shape[0]
    cols = xsize
    rows = ysize
    originX = xmin
    originY = ymin

    driver = gdal.GetDriverByName('GTiff')
    outRaster = driver.Create(newRasterfn, cols, rows, 1, gdal.GDT_Byte)
    outRaster.SetGeoTransform((originX, pixelWidth, 0, originY, 0, pixelHeight))
    outband = outRaster.GetRasterBand(1)
    outband.WriteArray(array)
    #outRasterSRS = osr.SpatialReference()
    #outRasterSRS.ImportFromEPSG(4326)
    #outRaster.SetProjection(outRasterSRS.ExportToWkt())
    outband.FlushCache()


def writeraster(newRasterfn,xmin,ymin,pixelWidth,pixelHeight,xsize,ysize,array):
    reversed_arr = array[::-1] # reverse array so the tif looks like the array
    array2raster(newRasterfn,xmin,ymin,pixelWidth,pixelHeight,xsize,ysize,reversed_arr) # convert array to raster

